import 'package:flutter/material.dart';

extension TextWidth on Text {
  double getLayoutWidth(BuildContext context, {TextStyle explicitTextStyle}) {
    assert(this.style != null || explicitTextStyle != null,
        "A TextStyle needs to be provided");

    var textWidget = Text.rich(
        TextSpan(text: this.data, style: explicitTextStyle ?? this.style));
    var textWidgetBuild = textWidget.build(context) as RichText;
    var renderObject = textWidgetBuild.createRenderObject(context)
      ..layout(BoxConstraints());
    var boxes = renderObject.getBoxesForSelection(
        TextSelection(baseOffset: 0, extentOffset: this.data.length));
    var textWidth = boxes.last.right;

    return textWidth;
  }
}
